require 'faraday'
require 'json'

module Acquia
  # @see https://cloudapi.acquia.com/
  class Cloud
    attr_reader :api

    def initialize(args = {})
      @api = Api.new args
    end

    def sites
      @sites ||= @api.get('/sites').map do |site|
        Site.new(self, site)
      end
    end

    # @return [Acquia::Cloud::Site]
    def site(name)
      Site.new(self, name).refresh
    end

    def drushrc
      @api.get '/me/drushrc'
    end
  end
end

%w{
  version
  errors
  credentials
  api
  database
  database_backup
  database_environment
  domain
  environment
  server
  site
  task
  logs/source
  logs/streamer
}.each {|p| require "acquia/cloud/#{p}" }
