require 'acquia/cloud/entity'

module Acquia
  class Cloud
    class DatabaseEnvironment < Database
      def initialize(cloud, site, environment, database)
        @cloud = cloud
        @site = site
        @environment = environment
        @data = database
        @url = "/sites/#{@site}/envs/#{@environment}/dbs/#{@data['name']}"
      end

      def db_cluster
        data['db_cluster']
      end

      def host
        data['host']
      end

      def instance_name
        data['instance_name']
      end

      def username
        data['username']
      end

      def password
        data['password']
      end

      def create_backup
        backup_on(@environment)
      end

      def backups
        @cloud.api.get("#{@url}/backups").map do |backup|
          DatabaseBackup.new(@cloud, @site, @environment, name, backup)
        end
      end

      def backup(id)
        DatabaseBackup.new(@cloud, @site, @environment, name, {'id' => id})
      end
    end
  end
end
