require 'acquia/cloud/entity'

module Acquia
  class Cloud
    class Task < Entity
      def initialize(cloud, site, task)
        @cloud = cloud
        @site = site
        @data = task
        @url = "/sites/#{@site}/tasks/#{@data['id']}"
      end

      def id
        data['id']
      end

      def queue
        data['queue']
      end

      def state
        data['state'].to_sym
      end

      def description
        data['description']
      end

      def created
        Time.at(data['created'].to_i)
      end

      def started
        Time.at(data['started'].to_i)
      end

      def completed
        Time.at(data['completed'].to_i)
      end

      def logs
        data['logs']
      end

      def wait_for_completion(message = nil)
        print message if message
        loop do
          # This will take several minutes, don't spam Acquia too hard while waiting.
          sleep 15
          print '.' if message
          refresh
          unless [:started].include? state
            puts if message
            break
          end
        end

        self
      end
    end
  end
end
